--
-- c_flag.lua
--

local scrX,scrY = guiGetScreenSize()

----------------------------------------------------------------
-- onClientResourceStart
----------------------------------------------------------------
addEventHandler( "onClientResourceStart", resourceRoot,
	function()
		-- Create things
        flagShader = dxCreateShader("flag.fx")
		flagTexture = dxCreateTexture("flag-pic.jpg")

		-- Check everything is ok
		bAllValid = flagShader and flagTexture

		if not bAllValid then
			outputChatBox( "Could not create some things. Please use debugscript 3" )
		else
			dxSetShaderValue( flagShader, "sFlagTexture", flagTexture )

			-- Customization enabled?
			if useGUI then
				createGui()		-- Do customization
			else
				setTypeA()		-- Set preset settings
			end
		end
	end
)


----------------------------------------------------------------
-- createGui
----------------------------------------------------------------
function createGui()

	local moveSize = 1
	initTableData = {
						{ "dxDrawImage" },
						{ 2, "Size", 0.1, 2, 0.5 },
						{ 2, "PosX", 0, 1, 0.5 },
						{ 2, "PosY", 0, 1, 0.5 },
						{ 0, "Alpha", 0, 255, 190 },
						{ "Flag shader" },
						{ 0, "sWireframe", 0, 1, 0 },
						{ 2, "sWaveFreq", 0, 6, 1.32 },
						{ 2, "sWaveSpeed", 0, 3, 0.63 },
						{ 2, "sWaveSize", 0, 4, 1 },
						{ 2, "sHighlightOffset", 0, 1, 0.29 },
						{ 2, "sHighlightAmount", 0, 1, 0.80 },
						{ "dxSetShaderTessellation" },
						{ 0, "TesselateX", 1, 32, 16 },
						{ 0, "TesselateY", 1, 8, 1 },
						{ "dxSetShaderTransform" },
						{ 1, "RotateX", 0, 360, 0 },
						{ 1, "RotateY", 0, 360, 0 },
						{ 1, "RotateZ", 0, 360, 0 },
						{ 2, "RotCenterOffsetX", -moveSize, moveSize, 0 },
						{ 2, "RotCenterOffsetY", -moveSize, moveSize, 0 },
						{ 2, "RotCenterOffsetZ", -moveSize, moveSize, 0 },
						{ 0, "RotCenIsScreen", 0, 1, 0 },
						{ 2, "PersCenterOffsetX", -moveSize, moveSize, 0 },
						{ 2, "PersCenterOffsetY", -moveSize, moveSize, 0 },
						{ 0, "PersCenIsScreen", 0, 1, 0 },
					}
	initSliders( "Flag", initTableData )
end

addEvent( "onClientChangedSettings" )
addEventHandler( "onClientChangedSettings", resourceRoot,
	function()
		if not flagShader then return end
		local v = Settings.var
		dxSetShaderValue( flagShader, "sWaveFreq", v.sWaveFreq )
		dxSetShaderValue( flagShader, "sWaveSpeed", v.sWaveSpeed )
		dxSetShaderValue( flagShader, "sWaveSize", v.sWaveSize * math.sqrt(v.Size) )
		dxSetShaderValue( flagShader, "sHighlightOffset", v.sHighlightOffset )
		dxSetShaderValue( flagShader, "sHighlightAmount", v.sHighlightAmount )
		dxSetShaderValue( flagShader, "sWireframe", math.floor(v.sWireframe+0.5) )
	end
)

-----------------------------------------------------------------------------------
-- onClientRender
-----------------------------------------------------------------------------------
addEventHandler( "onClientRender", root,
    function()
		if not bAllValid then return end
		if not Settings.var then return end
		local v = Settings.var

		-- Calculate pixel size
		local sizeX = v.Size * scrX
		local sizeY = sizeX * scrY / scrX

		-- Calculate pixel position (of center)
		local cenX = v.PosX * scrX
		local cenY = v.PosY * scrY
		-- Calculate pixel position (of top left)
		local posX = cenX - sizeX / 2
		local posY = cenY - sizeY / 2

		dxSetShaderTessellation( flagShader, v.TesselateX, v.TesselateY )

		dxSetShaderTransform( flagShader
						,v.RotateX, v.RotateY, v.RotateZ
						,v.RotCenterOffsetX, v.RotCenterOffsetY, v.RotCenterOffsetZ
						,v.RotCenIsScreen > 0.5
						,v.PersCenterOffsetX, v.PersCenterOffsetY
						,v.PersCenIsScreen > 0.5
						)

		dxDrawImage( posX, posY, sizeX, sizeY, flagShader, 0, 0, 0, tocolor(255,255,255,v.Alpha) )
    end
)


---------------------------------
function setTypeA()
    local v = Settings.var
    v.RotateZ=3.60
    v.PersCenterOffsetX=0
    v.PersCenterOffsetY=0
    v.sHighlightOffset=0.75
    v.RotateY=349.20
    v.TesselateX=14
    v.sWaveSize=0.36
    v.TesselateY=1
    v.Size=0.10
    v.RotateX=0
    v.PosY=0.87
    v.sWaveFreq=1.5
    v.Alpha=148
    v.sHighlightAmount=0.78
    v.PersCenIsScreen=0
    v.sWireframe=0
    v.RotCenterOffsetY=0
    v.RotCenterOffsetZ=0
    v.RotCenIsScreen=0
    v.RotCenterOffsetX=0
    v.sWaveSpeed=0.69
    v.PosX=0.93
	triggerEvent("onClientChangedSettings", resourceRoot)
end
---------------------------------
